.686
	
.model flat, stdcall
	
option casemap: none
	
	include \masm32\include\windows.inc
	
	include \masm32\include\kernel32.inc
	include \masm32\include\user32.inc
	include \masm32\include\comctl32.inc
	include \masm32\include\masm32.inc
	include MKHook.inc
	
	include resource.inc
	
	includelib \masm32\lib\kernel32.lib
	includelib \masm32\lib\user32.lib
	includelib \masm32\lib\comctl32.lib
	includelib \masm32\lib\masm32.lib
	includelib MKHook.lib
	
.radix 16
	
.data
	
	dlghnd dword 0
	
	wmsg MSG <>
	
	btnst dword 0
	btnhd dword 0
	
	mkp MKParams < <1,1>, <0,1>, <0,1>, <0,1> >
	
	state dword 0
	
	copydata COPYDATASTRUCT <0, sizeof MKParams, offset mkp>
	
	clcmd dword 0
	
	clabuf byte 128 dup(0)
	
.const
	
	iccex INITCOMMONCONTROLSEX <sizeof INITCOMMONCONTROLSEX, ICC_STANDARD_CLASSES>
	
	dlgclass byte "#32770", 0
	dlgtitle byte "MouseKeys", 0
	
	stradd byte "+", 0
	strsub byte "-", 0
	
	stract0 byte "Nothing", 0
	
	stract1 byte "Emulate left button", 0
	stract2 byte "Emulate right button", 0
	stract3 byte "Emulate middle button", 0
	
	stract4 byte "Click & hold left button", 0
	stract5 byte "Release left button", 0
	
	stract6 byte "Click & hold middle button", 0
	stract7 byte "Release middle button", 0
	
	stract8 byte "Click & hold right button", 0 
	stract9 byte "Release right button", 0
	
	stractA byte "Double-click left button", 0
	
	stractB byte "Rotate wheel forward", 0
	stractC byte "Rotate wheel backward", 0
	
	strstart byte "Start", 0
	strstop byte "Stop", 0
	
	strerr byte "Invalid parameter(s).", 0
	
.code
	
ecwproc proc hwnd:dword, lpar:dword
	
	mov eax, [hwnd]
	
	.if eax != [btnst] && eax != [btnhd]
		
		invoke EnableWindow, eax, [lpar]
		
	.endif
	
	mov eax, 1
	ret
	
ecwproc endp
	
fillactcb proc id:dword
	
	invoke SendDlgItemMessage, [dlghnd], [id], CB_ADDSTRING, 0, addr stract0
	invoke SendDlgItemMessage, [dlghnd], [id], CB_ADDSTRING, 0, addr stract1
	invoke SendDlgItemMessage, [dlghnd], [id], CB_ADDSTRING, 0, addr stract2
	invoke SendDlgItemMessage, [dlghnd], [id], CB_ADDSTRING, 0, addr stract3
	invoke SendDlgItemMessage, [dlghnd], [id], CB_ADDSTRING, 0, addr stract4
	invoke SendDlgItemMessage, [dlghnd], [id], CB_ADDSTRING, 0, addr stract5
	invoke SendDlgItemMessage, [dlghnd], [id], CB_ADDSTRING, 0, addr stract6
	invoke SendDlgItemMessage, [dlghnd], [id], CB_ADDSTRING, 0, addr stract7
	invoke SendDlgItemMessage, [dlghnd], [id], CB_ADDSTRING, 0, addr stract8
	invoke SendDlgItemMessage, [dlghnd], [id], CB_ADDSTRING, 0, addr stract9
	invoke SendDlgItemMessage, [dlghnd], [id], CB_ADDSTRING, 0, addr stractA
	invoke SendDlgItemMessage, [dlghnd], [id], CB_ADDSTRING, 0, addr stractB
	invoke SendDlgItemMessage, [dlghnd], [id], CB_ADDSTRING, 0, addr stractC
	
	ret
	
fillactcb endp
	
syncui proc uses ebx
	
	invoke SetDlgItemInt, [dlghnd], PTM_NUM, [mkp.ptm.numerator], 0
	invoke SetDlgItemInt, [dlghnd], PTM_DEN, [mkp.ptm.denominator], 0
	
	mov ebx, [mkp.at_shift.numerator]
	test ebx, ebx
	.if sign?
		mov eax, 1
		neg ebx
	.else
		xor eax, eax
	.endif
	invoke SendDlgItemMessage, [dlghnd], AS_WSHIFT, CB_SETCURSEL, eax, 0
	invoke SetDlgItemInt, [dlghnd], AT_SHIFT_NUM, ebx, 0
	invoke SetDlgItemInt, [dlghnd], AT_SHIFT_DEN, [mkp.at_shift.denominator], 0
	
	mov ebx, [mkp.at_ctrl.numerator]
	test ebx, ebx
	.if sign?
		mov eax, 1
		neg ebx
	.else
		xor eax, eax
	.endif
	invoke SendDlgItemMessage, [dlghnd], AS_WCTRL, CB_SETCURSEL, eax, 0
	invoke SetDlgItemInt, [dlghnd], AT_CTRL_NUM, ebx, 0
	invoke SetDlgItemInt, [dlghnd], AT_CTRL_DEN, [mkp.at_ctrl.denominator], 0
	
	mov ebx, [mkp.at_alt.numerator]
	test ebx, ebx
	.if sign?
		mov eax, 1
		neg ebx
	.else
		xor eax, eax
	.endif
	invoke SendDlgItemMessage, [dlghnd], AS_WALT, CB_SETCURSEL, eax, 0
	invoke SetDlgItemInt, [dlghnd], AT_ALT_NUM, ebx, 0
	invoke SetDlgItemInt, [dlghnd], AT_ALT_DEN, [mkp.at_alt.denominator], 0
	
	invoke SendDlgItemMessage, [dlghnd], ACT_INS, CB_SETCURSEL, [mkp.act_ins], 0
	invoke SendDlgItemMessage, [dlghnd], ACT_FIVE, CB_SETCURSEL, [mkp.act_five], 0
	invoke SendDlgItemMessage, [dlghnd], ACT_DEL, CB_SETCURSEL, [mkp.act_del], 0
	invoke SendDlgItemMessage, [dlghnd], ACT_DIV, CB_SETCURSEL, [mkp.act_div], 0
	invoke SendDlgItemMessage, [dlghnd], ACT_MUL, CB_SETCURSEL, [mkp.act_mul], 0
	invoke SendDlgItemMessage, [dlghnd], ACT_SUB, CB_SETCURSEL, [mkp.act_sub], 0
	invoke SendDlgItemMessage, [dlghnd], ACT_ADD, CB_SETCURSEL, [mkp.act_add], 0
	
	.if [mkp.use_when_numlock_is] != 0
		invoke SendDlgItemMessage, [dlghnd], NUMLOCKON, BM_SETCHECK, BST_CHECKED, 0
		invoke SendDlgItemMessage, [dlghnd], NUMLOCKOFF, BM_SETCHECK, BST_UNCHECKED, 0
	.else
		invoke SendDlgItemMessage, [dlghnd], NUMLOCKON, BM_SETCHECK, BST_UNCHECKED, 0
		invoke SendDlgItemMessage, [dlghnd], NUMLOCKOFF, BM_SETCHECK, BST_CHECKED, 0
	.endif
	
	ret
	
syncui endp
	
dlgproc proc hwnd:dword, msg:dword, wpar:dword, lpar:dword
	
	.if [msg] == WM_COMMAND
		
		.if word ptr [wpar + 2] == 0
			
			.if word ptr [wpar] == START
				
				.if [state] == 0
					
					invoke GetDlgItemInt, [hwnd], PTM_NUM, 0, 0
					mov [mkp.ptm.numerator], eax
					invoke GetDlgItemInt, [hwnd], PTM_DEN, 0, 0
					mov [mkp.ptm.denominator], eax
					
					invoke GetDlgItemInt, [hwnd], AT_SHIFT_NUM, 0, 0
					mov [mkp.at_shift.numerator], eax
					invoke GetDlgItemInt, [hwnd], AT_SHIFT_DEN, 0, 0
					mov [mkp.at_shift.denominator], eax
					invoke SendDlgItemMessage, [hwnd], AS_WSHIFT, CB_GETCURSEL, 0, 0
					.if eax != 0
						neg [mkp.at_shift.numerator]
					.endif
					
					invoke GetDlgItemInt, [hwnd], AT_CTRL_NUM, 0, 0
					mov [mkp.at_ctrl.numerator], eax
					invoke GetDlgItemInt, [hwnd], AT_CTRL_DEN, 0, 0
					mov [mkp.at_ctrl.denominator], eax
					invoke SendDlgItemMessage, [hwnd], AS_WCTRL, CB_GETCURSEL, 0, 0
					.if eax != 0
						neg [mkp.at_ctrl.numerator]
					.endif
					
					invoke GetDlgItemInt, [hwnd], AT_ALT_NUM, 0, 0
					mov [mkp.at_alt.numerator], eax
					invoke GetDlgItemInt, [hwnd], AT_ALT_DEN, 0, 0
					mov [mkp.at_alt.denominator], eax
					invoke SendDlgItemMessage, [hwnd], AS_WALT, CB_GETCURSEL, 0, 0
					.if eax != 0
						neg [mkp.at_alt.numerator]
					.endif
					
					invoke SendDlgItemMessage, [hwnd], ACT_INS, CB_GETCURSEL, 0, 0
					mov [mkp.act_ins], eax
					invoke SendDlgItemMessage, [hwnd], ACT_FIVE, CB_GETCURSEL, 0, 0
					mov [mkp.act_five], eax
					invoke SendDlgItemMessage, [hwnd], ACT_DEL, CB_GETCURSEL, 0, 0
					mov [mkp.act_del], eax
					invoke SendDlgItemMessage, [hwnd], ACT_DIV, CB_GETCURSEL, 0, 0
					mov [mkp.act_div], eax
					invoke SendDlgItemMessage, [hwnd], ACT_MUL, CB_GETCURSEL, 0, 0
					mov [mkp.act_mul], eax
					invoke SendDlgItemMessage, [hwnd], ACT_SUB, CB_GETCURSEL, 0, 0
					mov [mkp.act_sub], eax
					invoke SendDlgItemMessage, [hwnd], ACT_ADD, CB_GETCURSEL, 0, 0
					mov [mkp.act_add], eax
					
					invoke SendDlgItemMessage, [hwnd], NUMLOCKON, BM_GETCHECK, 0, 0
					.if eax == BST_CHECKED
						mov [mkp.use_when_numlock_is], 1
					.else
						mov [mkp.use_when_numlock_is], 0
					.endif
					
					invoke MKInstall, addr mkp
					
					.if eax != 0
						
						mov [state], 1
						
						invoke EnumChildWindows, [hwnd], addr ecwproc, 0
						invoke SetDlgItemText, [hwnd], START, addr strstop
						
					.else
						
						invoke ShowWindow, [hwnd], SW_SHOWNORMAL
						invoke MessageBox, [hwnd], addr strerr, 0, MB_ICONERROR
						
					.endif
					
				.else
					
					call MKUninstall
					
					mov [state], 0
					
					invoke EnumChildWindows, [hwnd], addr ecwproc, 1
					invoke SetDlgItemText, [hwnd], START, addr strstart
					
				.endif
				
			.elseif word ptr [wpar] == HIDE
				
				invoke ShowWindow, [hwnd], SW_HIDE
				
			.endif
			
		.endif
		
	.elseif [msg] == WM_COPYDATA
		
		mov ecx, [lpar]
		assume ecx : ptr COPYDATASTRUCT
		
		.if [ecx].cbData == sizeof MKParams && [ecx].lpData != 0
			
			.if [ecx].dwData == 1
				
				invoke MemCopy, [ecx].lpData, addr mkp, sizeof MKParams
				
				.if [state] != 0
					
					call MKUninstall
					
					mov [state], 0
					
					invoke EnumChildWindows, [hwnd], addr ecwproc, 1
					invoke SetDlgItemText, [hwnd], START, addr strstart
					
				.endif
				
				invoke syncui
				
				invoke MKInstall, addr mkp
				
				.if eax != 0
					
					mov [state], 1
					
					invoke EnumChildWindows, [hwnd], addr ecwproc, 0
					invoke SetDlgItemText, [hwnd], START, addr strstop
					
				.else
					
					invoke ShowWindow, [hwnd], SW_SHOWNORMAL
					invoke MessageBox, [hwnd], addr strerr, 0, MB_ICONERROR
					
				.endif
				
				mov eax, 1
				ret
				
			.elseif [ecx].dwData == 2
				
				.if [state] != 0
					
					call MKUninstall
					
					mov [state], 0
					
					invoke EnumChildWindows, [hwnd], addr ecwproc, 1
					invoke SetDlgItemText, [hwnd], START, addr strstart
					
				.endif
				
				mov eax, 1
				ret
				
			.endif
			
		.endif
		
		assume ecx : nothing
		
	.elseif [msg] == WM_INITDIALOG
		
		mov eax, [hwnd]
		mov [dlghnd], eax
		
		invoke SendDlgItemMessage, [hwnd], AS_WSHIFT, CB_ADDSTRING, 0, addr stradd
		invoke SendDlgItemMessage, [hwnd], AS_WSHIFT, CB_ADDSTRING, 0, addr strsub
		
		invoke SendDlgItemMessage, [hwnd], AS_WCTRL, CB_ADDSTRING, 0, addr stradd
		invoke SendDlgItemMessage, [hwnd], AS_WCTRL, CB_ADDSTRING, 0, addr strsub
		
		invoke SendDlgItemMessage, [hwnd], AS_WALT, CB_ADDSTRING, 0, addr stradd
		invoke SendDlgItemMessage, [hwnd], AS_WALT, CB_ADDSTRING, 0, addr strsub
		
		invoke fillactcb, ACT_INS
		invoke fillactcb, ACT_FIVE
		invoke fillactcb, ACT_DEL
		invoke fillactcb, ACT_DIV
		invoke fillactcb, ACT_MUL
		invoke fillactcb, ACT_SUB
		invoke fillactcb, ACT_ADD
		
		invoke GetDlgItem, [hwnd], START
		mov [btnst], eax
		
		invoke GetDlgItem, [hwnd], HIDE
		mov [btnhd], eax
		
		invoke syncui
		
		.if [clcmd] == 1
			invoke SendMessage, [hwnd], WM_COMMAND, START, [btnst]
		.endif
		
		mov eax, 1
		ret
		
	.elseif [msg] == WM_CLOSE
		
		.if [state] != 0
			
			call MKUninstall
			
		.endif
		
		invoke DestroyWindow, [hwnd]
		
	.elseif [msg] == WM_DESTROY
		
		invoke PostQuitMessage, 0
		
	.endif
	
	xor eax, eax
	ret
	
dlgproc endp
	
parseRational proc uses ebx \
				   s:ptr byte
	
	mov ebx, [s]
	movzx ecx, byte ptr [ebx]
	
	.if ecx == '-'
		mov eax, 1
		inc ebx
		movzx ecx, byte ptr [ebx]
	.else
		xor eax, eax
	.endif
	
	xor edx, edx
	
	.repeat
		
		.if ecx == 0
			.if eax == 0
				inc eax
			.else
				neg edx
			.endif
			ret
		.endif
		
		sub ecx, '0'
		
		.if sign? || ecx > 9
			xor eax, eax
			ret
		.endif
		
		lea edx, [edx*4 + edx]
		lea edx, [edx*2 + ecx]
		
		inc ebx
		movzx ecx, byte ptr [ebx]
		
	.until ecx == '/'
	
	.if eax != 0
		neg edx
		xor eax, eax
	.endif
	
	.while 1
		
		inc ebx
		movzx ecx, byte ptr [ebx]
		
		.if ecx == 0
			ret
		.endif
		
		sub ecx, '0'
		
		.if sign? || ecx > 9
			xor eax, eax
			ret
		.endif
		
		lea eax, [eax*4 + eax]
		lea eax, [eax*2 + ecx]
		
	.endw
	
parseRational endp
	
start:
	
	invoke GetCL, 1, addr clabuf
	.if eax == 1
		
		invoke szCmpi, addr strstart, addr clabuf, sizeof strstart - 1
		.if eax == 0
			
			mov [clcmd], 1
			
			push ebx
			
			mov ebx, 2
			
			.repeat
				
				invoke GetCL, ebx, addr clabuf
				cmp eax, 1
				jnz @F
				
				invoke parseRational, addr clabuf
				test eax, eax
				jz @F
				
				mov [mkp.ptm.numerator + ebx*8 - 2*8], edx
				mov [mkp.ptm.denominator + ebx*8 - 2*8], eax
				
				inc ebx
				
			.until ebx == 6
			
			.repeat
				
				invoke GetCL, ebx, addr clabuf
				cmp eax, 1
				jnz @F
				
				invoke ustr2dw, addr clabuf
				
				mov [mkp.act_ins + ebx*4 - 6*4], eax
				
				inc ebx
				
			.until ebx == 0E
			
		@@:	
			pop ebx
			
		.else
			
			invoke szCmpi, addr strstop, addr clabuf, sizeof strstop - 1
			.if eax == 0
				
				mov [clcmd], 2
				
			.endif
			
		.endif
		
	.endif
	
	invoke FindWindowEx, 0, 0, addr dlgclass, addr dlgtitle
	
	.if eax != 0
		
		.if [clcmd] == 0
			
			push eax
			
			invoke ShowWindow, eax, SW_SHOW
			
			call SetForegroundWindow
			
		.else
			
			mov edx, [clcmd]
			mov [copydata.dwData], edx
			
			invoke SendMessage, eax, WM_COPYDATA, 0, addr copydata
			
		.endif
		
	.elseif [clcmd] != 2
		
		invoke InitCommonControlsEx, addr iccex
		
		invoke GetModuleHandle, 0
		
		invoke CreateDialogParam, eax, DLG, 0, addr dlgproc, 0
		
		.if [clcmd] == 0
			
			invoke ShowWindow, eax, SW_SHOWNORMAL
			invoke UpdateWindow, [dlghnd]
			
		.endif
		
		.while 1
			
			invoke GetMessage, addr wmsg, 0, 0, 0
			.break .if eax == 0
			
			invoke IsDialogMessage, [dlghnd], addr wmsg
			
			.if eax == 0
				
				invoke TranslateMessage, addr wmsg
				invoke DispatchMessage, addr wmsg
				
			.endif
			
		.endw
		
	.endif
	
	invoke ExitProcess, 0
	
end start